#! /bin/bash

#author：yuansx
#date：2020-08-12

#only uos system

#参数1：安装包绝对路（带阅读器安装文件名称）
#参数2：阅读器包名
#包类型：deb/rpm

#example:
#./AutoUpdate.sh '/home/suwell/Desktop/0811/2cn.suwell.deb' 'suwellreaderpro' 'deb'
#./AutoUpdate.sh '/root/桌面/0803/suwellreaderpro-3.0.20.0803-1.mips64.rpm' 'suwellreaderpro' 'rpm'

PACK_DIR=$1
PACK_NAME=$2
PACK_DEB_RPM=$3

echo 'start update .................'
echo '============= params list ===================='
echo 'PACK_DIR:' $PACK_DIR
echo 'PACK_NAME:' $PACK_NAME
echo '=============================================='

#deb
update_for_deb(){
	P_PATH=$1
	P_NAME=$2	
	x=`dpkg -l | grep $P_NAME`
	if [ `dpkg -l | grep $P_NAME |wc -l` -ne 0 ];then
		echo -e "the packet_list: \n$x"
		sudo dpkg -r ${P_NAME}
		sudo rm -rf "/opt/suwell"
		sudo rm -rf "/opt/app/cn.suwell.reader"
	else
		echo "no install $P_NAME"
	fi

	echo '============= update suwellreader ============'
	echo 'start update install suwell reader...'
	sudo dpkg -i $P_PATH
	echo '=============================================='
}

#rpm
update_for_rpm(){
	P_PATH=$1
	P_NAME=$2

	if rpm -q $P_NAME &>/dev/null; then
		echo "${P_NAME} is already installed."
		echo "start sudo rpm -e --nodeps ${P_NAME}"
		sudo rpm -e --nodeps ${P_NAME}
	else
		echo "${P_NAME} is not installed!"
	fi

	echo '============= update suwellreader ============'
	echo 'start update install suwell reader...'	
	sudo rpm -ivh $P_PATH --nodeps --force		
	echo '============= update suwellreader ============'
}

process=$(ps -e | grep -iw SuwellReader | cut -b -5)
if [ -n "$process" ]; then    
	#killall SuwellReader &>/dev/null || true
	#killall SuwellReader
	#sleep 3
	#killall -9 SuwellReader
	killall suwellreader
	sleep 3
	killall -9 suwellreader
fi

if [ -f "/tmp/suwellreader/setup.ini" ]; then
	sudo rm -rf "/tmp/suwellreader/setup.ini"
fi

#deb
if [ "$PACK_DEB_RPM" == "deb" ];then
	update_for_deb ${PACK_DIR} ${PACK_NAME}
fi

#rpm
if [ "$PACK_DEB_RPM" == "rpm" ];then
	update_for_rpm ${PACK_DIR} ${PACK_NAME}
fi

#write flag
if [ -f "/tmp/suwellreader/setup.ini" ]; then
	sudo rm -rf "/tmp/suwellreader/setup.ini"
fi
#echo "setupstatus=1" >> '/tmp/suwellreader/setup.ini'

echo "[setup]" >> '/tmp/suwellreader/setup.ini'
echo "setupstatus=1" >> '/tmp/suwellreader/setup.ini'

echo 'finished .................'
echo ''

exit 0
